                   // Fichier genere avec ./genere A
#include "A.h"

//--
A::A(int a) : _a(a)
{
}

//--
A::A(const A& anA)
{
 _copy(anA);
}

//--
A& A::operator=(const A& anA)
{
 if (this != &anA)
 {
  _destroy();
  _copy(anA);
 }
 return *this;
}

//--
A::~A(void)
{
 _destroy();
}

//--
bool operator==(const A& anA1, const A& anA2)
{
 return anA1.isEqualTo(anA2);
}

//--
bool operator!=(const A& anA1, const A& anA2)
{
 return !(anA1==anA2);
}

//--
ostream& operator<<(ostream& os, const A& anA)
{
 anA.display(os);
 return os;
}

//--
void A::display(ostream& os) const
{
 os << "A::[" << _a << "]";
}

//--
bool A::isEqualTo(const A& anA) const
{
 if (_a != anA._a) return false;
 return true;
}

//--
void A::_copy(const A& anA)
{
 _a = anA._a;
}

//--
void A::_destroy(void)
{
}

