// uniquement en C++

#include <iostream>
using namespace std;

// Attention, min existant deja ==> nom de fonction : minimum

template <class T> // T : type formel
T minimum(T a, T b)
{
 return a < b ? a : b;
}

template <class T> // T : type formel
T minimum(const T* t, int n)
{
 T minVal = t[0];             // On suppose qu'il y a au moins un element !
 for(int i = 1; i < n; i++)
 if(t[i] < minVal) minVal = t[i];
 return minVal;
}

int main(void)
{
 int    iT[] = {1, 9, 3, 0};
 double dT[] = {1.3, 9.2, 3.4, 0.7};

 cout << "minimum(3,2)     => " << minimum(3,2)     << endl;
 cout << "minimum(3.9,2.3) => " << minimum(3.9,2.3) << endl;

 cout << "minimum(iT)      => " << minimum(iT,4)    << endl;
 cout << "minimum(dT)      => " << minimum(dT,4)    << endl;

 return 0;
}
