// Point.h

#ifndef POINT_H
#define POINT_H

class Point {
 public:

  // Constructeurs - Destructeur

             Point(int x = 0, int y = 0) : _x(x), _y(y) {}
             Point(const Point& p) : _x(p._x), _y(p._y) {}
    virtual ~Point(void) {}

  // Operations

    int  getx(void) const;
    int  gety(void) const;
    void display(void) const;
    void set(int x, int y);
    void move(int dx, int dy);

 private:

  // Attributs
    int _x;
    int _y;
};

#endif // POINT_H
