// Point.cpp

#include <iostream>
#include "Point.h"

using namespace std;

const char* Point::_className = "Point";

const char* Point::getClassName(void)
{
 return _className;
}

int Point::getx(void) const
{
 return _x;
}

int Point::gety(void) const
{
 return _y;
}

void Point::display(void) const
{
 cout << '(' << _x << ',' << _y << ')';
}

void Point::set(int x, int y)
{
 _x = x;
 _y = y;
}

void Point::move(int dx, int dy)
{
 _x += dx;
 _y += dy;
}
