#include <iostream>
#include "DynamicArray.h"
#include "AbstractArray.cpp" // Pour les classes template et g++ !
#include "DynamicArray.cpp"  // Pour les classes template et g++ !

using namespace std;

int times(const int& x, const int& y) { return x * y; }

int main(void)
{
 int i = 0;
 DynamicArray<int> a1;
 DynamicArray<int>* a2 = new DynamicArray<int>(2);
 DynamicArray< DynamicArray<int> > a(1);

 cout << "a1 = " << a1 << ',';
 cout << "a2 = " << (*a2) << ',';
 cout << "a = "  << a << endl;

 a1 << 1 << 2 << 3 << 4 << 5;
 (*a2) << 6 << 7;

 a << a1 << (*a2) << (a1 + (*a2));

 cout << "a1 = " << a1 << " : " << a1(1,times) << endl;
 cout << "a2 = " << (*a2) << endl;
 cout << "a = " << a << endl;

 a1 += (*a2);
 cout << "a1 = " << a1 << endl;

 while(!a1.empty()) { a1 >> i; cout << i << ' '; }

 cout << endl << "a1 = " << a1 << endl;

 while(!a.empty()) { a >> (*a2); cout << (*a2) << ' '; }

 cout << endl << "a = " << a << endl;

 delete a2;

 return 0;
}
