#include <iostream>
#include <vector>

using namespace std;

const int MAX=10;

int main(void)
{
 vector<int> v;

 cout << endl;
 cout << "------- Exemples 1-2-3 STL: conteneur vector"          << endl;
 cout << "==> Initialisation du vector avec des push_back"       << endl;
 cout << endl;

 for(size_t i=0;i<MAX;i++)
 {
  v.push_back(i);
 }

 cout << endl;
 cout << "------- Exemple 1 STL: conteneur vector"               << endl;
 cout << "==> Parcours avec operateur [] sur un vecteur"         << endl;
 cout << endl;

 for(size_t i=0;i<v.size();i++)
 {
  cout << " " << v[i]; // operateur [] pris en charge par la classe vector
 }
 cout << endl;

 cout << endl;
 cout << "------- Exemple 2 STL: conteneur vector"               << endl;
 cout << "==> Parcours avec un iterator sur un vecteur"          << endl;
 cout << endl;

 for(vector<int>::iterator it=v.begin();it!=v.end();it++)
 {                     // un iterator: peut etre vu comme un pointeur
  cout << " " << *it;  // que l'on deplace le long du conteneur
 }
 cout << endl;

 cout << endl;
 cout << "------- Exemple 3 STL: conteneur vector"               << endl;
 cout << "==> Parcours avec un reverse_iterator sur un vecteur"  << endl;
 cout << endl;

 for(vector<int>::reverse_iterator rit=v.rbegin();rit!=v.rend();rit++)
 {                      // un iterator: peut etre vu comme un pointeur
  cout << " " << *rit;  // que l'on deplace en sens inverse (reverse)
 }                      // le long du conteneur
 cout << endl;

 return 0;
}
