#include <assert.h> // Fichier Stack.cpp
#include "Stack.h"

template <class T>
Stack<T>::Stack(void) : _size(0) {}

template <class T>
Stack<T>::~Stack(void) {}

template <class T>
bool Stack<T>::empty(void) const { return _size == 0; }

template <class T>
int Stack<T>::size(void) const { return _size; }

template <class T>
const T& Stack<T>::top(void) const {
 assert(!empty());
 return _stack[_size - 1];
}

template <class T>
void Stack<T>::push(const T& t) {
 assert(_size < MAX);
 _stack[_size++] = t;
}

template <class T>
T Stack<T>::pop(void) {
 assert(!empty());
 return _stack[--_size];
}
