#ifndef STACK_H
#define STACK_H

const int MAX = 10;

template <class T>
class Stack {                  // Fichier Stack.h

 public :
   Stack(void);
  ~Stack(void);
   bool empty(void) const;
   int size(void) const;
   const T& top(void) const;
   void push(const T& t);
   T pop(void);
 private :
   T _stack[MAX];
   int _size;
};

#endif // STACK_H
