// Point.cpp

#include <iostream>
#include "Point.h"

using namespace std;

int Point::getx(void) const
{
 return this->_x;                 // return _x;
}

int Point::gety(void) const
{
 return this->_y;                 // return _y;
}

void Point::display(void) const
{
 cout << '(' << _x << ',' << _y << ')';
}

void Point::set(int x, int y)
{
 (*this)._x = x;
 (*this)._y = y;
}

void Point::move(int dx, int dy)
{
 this->_x += dx;
 this->_y += dy;
}
