#ifndef C_H
#define C_H

#include <iostream>

using namespace std;

class C
{
   friend ostream& operator<<(ostream& os, const C& c);

 public :

   // Cllocateurs/Desallocateurs

            C(int v = 0);
            C(const C& c);
            C& operator=(const C& c);
   virtual ~C(void);

   // Comparaisons

   friend  bool operator==(const C& c1, const C& c2);
   friend  bool operator!=(const C& c1, const C& c2);

 private :

   // Attributs

             int  _v;
             int* _pv;

   // Methodes privees d'allocation/desallocation

   void _copy(const C& c);
   void _destroy(void);

};

#endif // C_H
