// Point.h

#ifndef POINT_H
#define POINT_H

class Point {

    friend void display(const Point& p);

 public:

  // Constructeurs - Destructeur

             Point(int x = 0, int y = 0);
             Point(const Point& p);
    virtual ~Point(void);

  // Operations

    int  getx(void) const;
    int  gety(void) const;
    void set(int x, int y);
    void move(int dx, int dy);

 private:

  // Attributs
    int _x;
    int _y;
};

#endif // POINT_H
