#ifndef _A_H_
#define _A_H_

#include <iostream>

using namespace std;

class A
{
   friend ostream& operator<<(ostream& os, const A& anA);

 public :

   // Allocateurs/Desallocateurs

            A(int i=0);
            A(const A& anA);
            A& operator=(const A& anA);
   virtual ~A(void);

   // Comparaisons

   friend  bool operator==(const A& anA1, const A& anA2);
   friend  bool operator!=(const A& anA1, const A& anA2);

   // Inspecteurs/modificateurs

          A& operator+=(const A& anA);
   friend A  operator+(const A& anA1, const A& anA2);  // + : non membre

          A& operator*=(const A& anA);
          A  operator*(const A& anA);                  // * : membre

 protected :


 private :

          int _i;

 private :

   // Methodes privees d'allocation/desallocation

   void _copy(const A& anA);
   void _destroy(void);
};

#endif // _A_H_
