#include <iostream>
#include "Base.h"
#include "Base.cpp"
#include "Derived.h"
#include "Derived.cpp"

using namespace std;

int main(void)
{
 int i=10;

//----------- b1
 Base<double,int> b1;

 cout << "b1 avant initialisation: " << b1 << endl;

 b1.setBaseObject(1.0);
 b1.setBasePointer(&i);

 cout << "b1 apres initialisation: " << b1 << endl;

//----------- d1
 Derived<double,int,char> d1;

 cout << "d1 avant initialisation: " << d1 << endl;

 d1.setBaseObject(1.0);
 d1.setBasePointer(&i);
 d1.setDerivedObject('a');

 cout << "d1 apres initialisation: " << d1 << endl;

//----------- ==
 if (b1==d1) cout << "b1 Egal d1"     << endl;
 else        cout << "b1 Pas egal d1" << endl;

//----------- =
 Base<double,int> b2;

 cout << "b2 avant b2=d1: " << b2 << endl;

 b2 = d1;

 cout << "b2 apres b2=d1: " << b2 << endl;

 return 0;
}
